#ifdef USE_QT

#include "bbtkQtBlackBoxDialog.h"
#include "bbtkQtBlackBox.h"

namespace bbtk
{


  //=========================================================================
  QtBlackBoxDialog::QtBlackBoxDialog(QtBlackBox::Pointer box,
				     QWidget *parent,
				     const std::string& title,
				     int width, int height)

    :
    QDialog(parent),
    mBox(box)
				    //    QDialog( parent )
  {
    bbtkDebugMessage("widget",9,"["<<
		     box->bbGetName()<<"] QtBlackBoxDialog("<<parent<<",\""
		     <<title<<"\","<<width<<"x"<<height<<")"<<std::endl);
    Qt::IncNbWindowsAlive();
    // Sets up the GUI inherited from Ui::bbtkQtblackBoxDialog
    setupUi(this);
    resize ( width  , height );
    setWindowTitle(title.c_str());
    
    ///
    box->bbSetWindow(this);
   // Create the widget
    box->bbUserCreateWidget(widget);

    // Insert into the layout
    horizontalLayout->addWidget(box->bbGetOutputWidget());

 
    //    updateGeometry();

  }
  //=========================================================================
  
 
  //=========================================================================
  QtBlackBoxDialog::~QtBlackBoxDialog()
  {
    if (mBox.lock())
      bbtkDebugMessage("widget",9,"["<<mBox.lock()->bbGetName()
		       <<"] $$$$$$$$$$$$$$$$$$$ ~QtBlackBoxDialog()"
		       <<std::endl);
    else 
      bbtkDebugMessage("widget",9,"[DEAD] $$$$$$$$$$$$$$$$$$$$$ ~QtBlackBoxDialog()"<<std::endl);
    //bbtkDebugMessage("widget",9,"WxFrame::~WxFrame()"<<std::endl);
    if (mBox.lock()) mBox.lock()->bbSetWindow(0); 
    Qt::DecNbWindowsAlive();
  }
  //=========================================================================

}
#endif

