/*=========================================================================                                                                               
  Program:   bbtk
  Module:    $RCSfile: bbtkWxGUIOutputMessages.h,v $
  Language:  C++
  Date:      $Date: 2008/10/17 08:18:15 $
  Version:   $Revision: 1.3 $
=========================================================================*/

/* ---------------------------------------------------------------------

* Copyright (c) CREATIS-LRMN (Centre de Recherche en Imagerie Medicale)
* Authors : Eduardo Davila, Laurent Guigues, Jean-Pierre Roux
*
*  This software is governed by the CeCILL-B license under French law and 
*  abiding by the rules of distribution of free software. You can  use, 
*  modify and/ or redistribute the software under the terms of the CeCILL-B 
*  license as circulated by CEA, CNRS and INRIA at the following URL 
*  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html 
*  or in the file LICENSE.txt.
*
*  As a counterpart to the access to the source code and  rights to copy,
*  modify and redistribute granted by the license, users are provided only
*  with a limited warranty  and the software's author,  the holder of the
*  economic rights,  and the successive licensors  have only  limited
*  liability. 
*
*  The fact that you are presently reading this means that you have had
*  knowledge of the CeCILL-B license and that you accept its terms.
* ------------------------------------------------------------------------ */                                                                         


/**
 * \brief Short description in one line
 * 
 * Long description which 
 * can span multiple lines
 */
/**
 * \file 
 * \brief 
 */
/**
 * \class bbtk::
 * \brief 
 */


#ifdef _USE_WXWIDGETS_

	
#ifndef __bbtkWxGUIOutputMessages_h__
#define __bbtkWxGUIOutputMessages_h__

#include "bbtkWx.h"
 

namespace bbtk
{
  
   /// Abstract class which defines the callbacks invoked by WxGUIOutputMessages
  class BBTK_EXPORT WxGUIOutputMessagesUser
  {
  public:
    WxGUIOutputMessagesUser() {}
    virtual ~WxGUIOutputMessagesUser() {}
    /// Callback invoked when a command is entered in the WxGUIOutputMessages
    virtual void WxGUIOutputMessagesEnter(const std::string& command) {}
  };
  

  // Forward decl
  class WxStreamRedirector;

  /// GUI Component which provides a command input zone 
  class BBTK_EXPORT WxGUIOutputMessages : public wxPanel
  {
  public:
    WxGUIOutputMessages(wxWindow *parent, WxGUIOutputMessagesUser* user = 0);
    ~WxGUIOutputMessages();
    
    void Print(const std::string& message, const wxColor* col = 0);

  private :
    WxGUIOutputMessagesUser* mUser;
    wxTextCtrl* mwxOutputText;
    wxTextAttr* mwxOutputTextAttr;
    WxStreamRedirector* mRedirect_cout;
    WxStreamRedirector* mRedirect_cerr;
    /*
  public:
    enum
      {
	ID_Text_Command,
	ID_Btn_Go,
	ID_Btn_Include,
	ID_Btn_Reset,
	ID_Btn_Config,
	ID_Btn_GraphS,
	ID_Btn_GraphD,
	ID_Btn_Help
      };
    
    DECLARE_EVENT_TABLE()
    */
  };
  
  
} // namespace bbtk


#endif // __bbtkWxGUIOutputMessages_h__

#endif //_USE_WXWIDGETS_
