/*=========================================================================                                                                               
  Program:   bbtk
  Module:    $RCSfile: bbitkImageToString.cxx,v $
  Language:  C++
  Date:      $Date: 2008/10/17 08:18:21 $
  Version:   $Revision: 1.4 $
=========================================================================*/

/* ---------------------------------------------------------------------

* Copyright (c) CREATIS-LRMN (Centre de Recherche en Imagerie Medicale)
* Authors : Eduardo Davila, Laurent Guigues, Jean-Pierre Roux
*
*  This software is governed by the CeCILL-B license under French law and 
*  abiding by the rules of distribution of free software. You can  use, 
*  modify and/ or redistribute the software under the terms of the CeCILL-B 
*  license as circulated by CEA, CNRS and INRIA at the following URL 
*  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html 
*  or in the file LICENSE.txt.
*
*  As a counterpart to the access to the source code and  rights to copy,
*  modify and redistribute granted by the license, users are provided only
*  with a limited warranty  and the software's author,  the holder of the
*  economic rights,  and the successive licensors  have only  limited
*  liability. 
*
*  The fact that you are presently reading this means that you have had
*  knowledge of the CeCILL-B license and that you accept its terms.
* ------------------------------------------------------------------------ */                                                                         


#ifdef _USE_ITK_

#include "bbstdToString.h"
#include "bbitkImage.h"
#include "bbitkPackage.h"
#include <sstream>

namespace bbstd
{
  
  
  //====================================================================
  BBTK_BLACK_BOX_TEMPLATE_IMPLEMENTATION(ToString,
					 bbtk::AtomicBlackBox);
  //====================================================================
  
  //====================================================================
  template <> void ToString<bbtk::any<bbitk::ImagePointer> > ::DoIt()
  {
    std::ostringstream s;
    itk::Object* o1 = bbGetInputIn().unsafe_get<itk::Object*>();
    o1->Print(s);
    
    bbSetOutputOut( s.str() );
  }
  //====================================================================
} // namespace bbstd


using namespace bbstd;
namespace bbitk 
{
  //  typedef bbstd::ToString ToString;
  //====================================================================
  // Add the specialized adaptors to the package
  typedef bbitk::anyImagePointer anyItkImagePointer;
  BBTK_ADD_TEMPLATE_BLACK_BOX_TO_PACKAGE(itk,ToString,
					 anyItkImagePointer);
  //typedef const bbtk::itkImage* itkImageConstPointer;
  //BBTK_ADD_TEMPLATE_BLACK_BOX_TO_PACKAGE(itkBase,ScalarToString,itkImageConstPointer);
  
}


#endif //_USE_ITK_
