/*=========================================================================                                                                               
  Program:   bbtk
  Module:    $RCSfile: bbkwSlicer.h,v $
  Language:  C++
  Date:      $Date: 2008/12/03 13:35:27 $
  Version:   $Revision: 1.3 $
=========================================================================*/

/* ---------------------------------------------------------------------

* Copyright (c) CREATIS-LRMN (Centre de Recherche en Imagerie Medicale)
* Authors : Eduardo Davila, Laurent Guigues, Jean-Pierre Roux
*
*  This software is governed by the CeCILL-B license under French law and 
*  abiding by the rules of distribution of free software. You can  use, 
*  modify and/ or redistribute the software under the terms of the CeCILL-B 
*  license as circulated by CEA, CNRS and INRIA at the following URL 
*  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html 
*  or in the file LICENSE.txt.
*
*  As a counterpart to the access to the source code and  rights to copy,
*  modify and redistribute granted by the license, users are provided only
*  with a limited warranty  and the software's author,  the holder of the
*  economic rights,  and the successive licensors  have only  limited
*  liability. 
*
*  The fact that you are presently reading this means that you have had
*  knowledge of the CeCILL-B license and that you accept its terms.
* ------------------------------------------------------------------------ */                                                                         

/**
 * \file 
 * \brief Short description in one line
 * 
 * Long description which 
 * can span multiple lines
*/

/**
 * \class bbkw::Slicer
 * \brief 

 * \class bbkw::SlicerWidget
 * \brief 
 */

#ifdef USE_KWWIDGETS

// Prevents multiple inclusions : use symbols of the form
// __FILENAME_INCLUDED__ 
// where FILENAME must be replaced by the actual file name
#ifndef __bbkwSlicer_h_INCLUDED__
#define __bbkwSlicer_h_INCLUDED__

// Include KWBlackBox definition
#include "bbtkKWBlackBox.h"

class vtkImageData;

// Namespace of the package "kw" is "bbkw" 
// Namespace associated to packages should be of the form :
// bbPACKAGENAME
namespace bbkw
{
  
  
  //------------------------------------------------------------------------
  class /*BBTK_EXPORT*/ Slicer : public bbtk::KWBlackBox
  {
    
    BBTK_BLACK_BOX_INTERFACE(Slicer,bbtk::KWBlackBox);
    BBTK_DECLARE_INPUT(In,vtkImageData*);
    BBTK_PROCESS(Process);
    BBTK_CREATE_KWWIDGET(CreateWidget);
    void Process();
    void CreateWidget(vtkKWFrame*);

  protected:
    virtual void bbUserConstructor();
  };
  //=================================================================
 
  //=================================================================
  // the black box description
  BBTK_BEGIN_DESCRIBE_BLACK_BOX(Slicer,bbtk::KWBlackBox);
  BBTK_NAME("kwSlicer");
  BBTK_AUTHOR("laurent.guigues@creatis.insa-lyon.fr");
  // Already inserted for any KWBlackBox  BBTK_CATEGORY("widget");
  BBTK_DESCRIPTION("Slicer widget (vtkKWSlicer)");
  BBTK_INPUT(Slicer,In,"Image to display",vtkImageData*,"");
  BBTK_END_DESCRIBE_BLACK_BOX(Slicer);
  //=================================================================
  


} //namespace bbkw

#endif  //__bbtkkwSlicer_h_INCLUDED__

#endif // USE_KWWIDGETS
