/*=========================================================================
                                                                                
  Program:   bbtk
  Module:    $RCSfile: bbkwViewer3D.cxx,v $
  Language:  C++
  Date:      $Date: 2008/12/16 12:48:08 $
  Version:   $Revision: 1.1 $
                                                                                
  Copyright (c) CREATIS (Centre de Recherche et d'Applications en Traitement de
  l'Image). All rights reserved. See Doc/License.txt or
  http://www.creatis.insa-lyon.fr/Public/bbtk/License.html for details.
                                                                                
     This software is distributed WITHOUT ANY WARRANTY; without even
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
     PURPOSE.  See the above copyright notices for more information.
                                                                                
=========================================================================*/
/**
 *  \file 
 *  \brief 
 */


#ifdef _USE_WXWIDGETS_


#include "bbkwViewer3D.h"
#include "bbkwPackage.h"

#include "vtkKWRenderWidget.h"

namespace bbkw
{

  BBTK_ADD_BLACK_BOX_TO_PACKAGE(kw,kwViewer3D);
  BBTK_BLACK_BOX_IMPLEMENTATION(kwViewer3D,bbtk::KWBlackBox);

  void kwViewer3D::bbUserConstructor() 
  { 
    bbSetInputIn1(NULL);
    bbSetInputIn2(NULL);
    bbSetInputIn3(NULL);
    bbSetInputIn4(NULL);
    bbSetInputIn5(NULL);
    bbSetInputObs1(NULL);
    bbSetInputObs2(NULL);
    bbSetInputObs3(NULL);
    bbSetInputObs4(NULL);
    bbSetInputObs5(NULL);
    bbSetOutputWidget(NULL);
  }
  
  void kwViewer3D::bbUserDestructor() 
  { 
    /*
   vtkKWRenderWidget* w = (vtkKWRenderWidget*)bbGetOutputWidget();
    if (w) 
      {
	w->Delete();
      }
    */
  }

  void kwViewer3D::Process() 
  { 
    vtkKWRenderWidget* w = (vtkKWRenderWidget*)bbGetOutputWidget();
    if (w) 
      {
	if ( (bbGetInputIn1()!=NULL) &&
	     (bbGetInputStatus("In1")!=bbtk::UPTODATE))
	  {
	    w->AddViewProp(bbGetInputIn1());
	  }
	if ( (bbGetInputIn2()!=NULL) &&
	     (bbGetInputStatus("In2")!=bbtk::UPTODATE))
	  {
	    w->AddViewProp(bbGetInputIn2());
	  }
	if ( (bbGetInputIn3()!=NULL) &&
	     (bbGetInputStatus("In3")!=bbtk::UPTODATE))
	  {
	    w->AddViewProp(bbGetInputIn3());
	  }
	if ( (bbGetInputIn4()!=NULL) &&
	     (bbGetInputStatus("In4")!=bbtk::UPTODATE))
	  {
	    w->AddViewProp(bbGetInputIn4());
	  }
	if ( (bbGetInputIn5()!=NULL) &&
	     (bbGetInputStatus("In5")!=bbtk::UPTODATE))
	  {
	    w->AddViewProp(bbGetInputIn5());
	  }
	w->ResetCamera();
	w->Render();
      }
  }
  

  void kwViewer3D::CreateWidget(vtkKWFrame* parent)
  {
    vtkKWRenderWidget *w = vtkKWRenderWidget::New();
    bbSetOutputWidget(w);
    w->SetParent((vtkKWWidget*)parent);
    w->Create();
    w->SetRenderModeToInteractive();

    Process();
    w->Delete();
    /*
    vtkRenderWindowInteractor *interactor = w->GetInteractor();
    if (interactor!=NULL)
      {
	if (bbGetInputObs1()!=NULL) 
	  {
	    bbGetInputObs1()->SetInteractor(interactor);
	    bbGetInputObs1()->EnabledOn();
	  }
	if (bbGetInputObs2()!=NULL) 
	  {
	    bbGetInputObs2()->SetInteractor(interactor);
	    bbGetInputObs2()->EnabledOn();
	  }
	if (bbGetInputObs3()!=NULL) 
	  {
	    bbGetInputObs3()->SetInteractor(interactor);
	    bbGetInputObs3()->EnabledOn();
	  }
	if (bbGetInputObs4()!=NULL) 
	  {
	    bbGetInputObs4()->SetInteractor(interactor);
	    bbGetInputObs4()->EnabledOn();
	  }
	if (bbGetInputObs5()!=NULL) 
	  {
	    bbGetInputObs5()->SetInteractor(interactor);
	    bbGetInputObs5()->EnabledOn();
	  }
	bbSetOutputInteractor(  w->GetInteractor() );
      }
   

    */
    
  }




}//namespace bbkw

#endif

