/*=========================================================================                                                                               
  Program:   bbtk
  Module:    $RCSfile: bbqtLayoutSplit.cxx,v $
  Language:  C++
  Date:      $Date: 2009/05/28 14:22:15 $
  Version:   $Revision: 1.3 $
=========================================================================*/

/* ---------------------------------------------------------------------

* Copyright (c) CREATIS-LRMN (Centre de Recherche en Imagerie Medicale)
* Authors : Eduardo Davila, Laurent Guigues, Jean-Pierre Roux
*
*  This software is governed by the CeCILL-B license under French law and 
*  abiding by the rules of distribution of free software. You can  use, 
*  modify and/ or redistribute the software under the terms of the CeCILL-B 
*  license as circulated by CEA, CNRS and INRIA at the following URL 
*  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html 
*  or in the file LICENSE.txt.
*
*  As a counterpart to the access to the source code and  rights to copy,
*  modify and redistribute granted by the license, users are provided only
*  with a limited warranty  and the software's author,  the holder of the
*  economic rights,  and the successive licensors  have only  limited
*  liability. 
*
*  The fact that you are presently reading this means that you have had
*  knowledge of the CeCILL-B license and that you accept its terms.
* ------------------------------------------------------------------------ */                                                                         

/**
 *  \file
 *  \brief
 */


#ifdef USE_QT

#include "bbqtLayoutSplit.h"
#include "bbqtPackage.h"
#include "bbtkUtilities.h"

#include <QSplitter>

namespace bbqt
{
  BBTK_ADD_BLACK_BOX_TO_PACKAGE(qt,LayoutSplit);
  BBTK_BLACK_BOX_IMPLEMENTATION(LayoutSplit,bbtk::QtBlackBox);

	
  void LayoutSplit::bbUserSetDefaultValues()
  {
    bbSetInputOrientation("VERTICAL");
    //    bbSetInputProportion(50);

    bbSetInputWidget1(NULL);
    bbSetInputWidget2(NULL);
    bbSetInputWidget3(NULL);
    bbSetInputWidget4(NULL);
    bbSetInputWidget5(NULL);
    bbSetInputWidget6(NULL);
    bbSetInputWidget7(NULL);
    bbSetInputWidget8(NULL);
    bbSetInputWidget9(NULL);

    bbSetInputWeight1(1);
    bbSetInputWeight2(1);
    bbSetInputWeight3(1);
    bbSetInputWeight4(1);
    bbSetInputWeight5(1);
    bbSetInputWeight6(1);
    bbSetInputWeight7(1);
    bbSetInputWeight8(1);
    bbSetInputWeight9(1);
  }

	
	void LayoutSplit::bbUserInitializeProcessing()
	{
	}
	
	void LayoutSplit::bbUserFinalizeProcessing()
	{
	}
	
	
	
	
  void LayoutSplit::Process()
  {
  }

  void LayoutSplit::CreateWidget(QWidget* parent)
  {
    Qt::Orientation ori;
    if (bbtk::Utilities::loosematch(bbGetInputOrientation(),
				    "0|H|HORIZONTAL")==true)  
      { ori = Qt::Horizontal; }
    if (bbtk::Utilities::loosematch(bbGetInputOrientation(),
				    "1|V|VERTICAL")==true) 	
      { ori = Qt::Vertical; }
    
    QSplitter* w = new QSplitter(ori,parent);
    QWidget* c;
    int i=0;
    if ((c=bbCreateWidgetOfInput("Widget1",w))!=0) 
      {
	w->addWidget(c);
	w->setStretchFactor(i,bbGetInputWeight1());
	i++;
      }
    if ((c=bbCreateWidgetOfInput("Widget2",w))!=0) 
      {
	w->addWidget(c);
	w->setStretchFactor(i,bbGetInputWeight2());
	i++;
      }
    if ((c=bbCreateWidgetOfInput("Widget3",w))!=0) 
      {
	w->addWidget(c);
	w->setStretchFactor(i,bbGetInputWeight3());
	i++;
      }
    if ((c=bbCreateWidgetOfInput("Widget4",w))!=0) 
      {
	w->addWidget(c);
	w->setStretchFactor(i,bbGetInputWeight4());
	i++;
      }
    if ((c=bbCreateWidgetOfInput("Widget5",w))!=0) 
      {
	w->addWidget(c);
	w->setStretchFactor(i,bbGetInputWeight5());
	i++;
      }
    if ((c=bbCreateWidgetOfInput("Widget6",w))!=0) 
      {
	w->addWidget(c);
	w->setStretchFactor(i,bbGetInputWeight6());
	i++;
      }
    if ((c=bbCreateWidgetOfInput("Widget7",w))!=0) 
      {
	w->addWidget(c);
	w->setStretchFactor(i,bbGetInputWeight7());
	i++;
      }
    if ((c=bbCreateWidgetOfInput("Widget8",w))!=0) 
      {
	w->addWidget(c);
	w->setStretchFactor(i,bbGetInputWeight8());
	i++;
      }
    if ((c=bbCreateWidgetOfInput("Widget9",w))!=0) 
      {
	w->addWidget(c);
	w->setStretchFactor(i,bbGetInputWeight9());
	i++;
      }
  
    bbSetOutputWidget( w );
  }


  // This callback is necessary to get actual processing of the view 
  // when window is shown
  void  LayoutSplit::OnShowWidget()
  {
    /*
    bbUserOnShowWidget("Widget1");
    bbUserOnShowWidget("Widget2");
    bbUserOnShowWidget("Widget3");
    bbUserOnShowWidget("Widget4");
    bbUserOnShowWidget("Widget5");
    bbUserOnShowWidget("Widget6");
    bbUserOnShowWidget("Widget7");
    bbUserOnShowWidget("Widget8");
    bbUserOnShowWidget("Widget9");
    */
  }



}//namespace bbqt

#endif // USE_QT

