/*=========================================================================                                                                               
  Program:   bbtk
  Module:    $RCSfile: bbstdConfiguration.h,v $
  Language:  C++
  Date:      $Date: 2009/05/14 14:43:38 $
  Version:   $Revision: 1.11 $
=========================================================================*/

/* ---------------------------------------------------------------------

* Copyright (c) CREATIS-LRMN (Centre de Recherche en Imagerie Medicale)
* Authors : Eduardo Davila, Laurent Guigues, Jean-Pierre Roux
*
*  This software is governed by the CeCILL-B license under French law and 
*  abiding by the rules of distribution of free software. You can  use, 
*  modify and/ or redistribute the software under the terms of the CeCILL-B 
*  license as circulated by CEA, CNRS and INRIA at the following URL 
*  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html 
*  or in the file LICENSE.txt.
*
*  As a counterpart to the access to the source code and  rights to copy,
*  modify and redistribute granted by the license, users are provided only
*  with a limited warranty  and the software's author,  the holder of the
*  economic rights,  and the successive licensors  have only  limited
*  liability. 
*
*  The fact that you are presently reading this means that you have had
*  knowledge of the CeCILL-B license and that you accept its terms.
* ------------------------------------------------------------------------ */                                                                         


#ifndef __bbstdConfiguration_h_INCLUDED__
#define __bbstdConfiguration_h_INCLUDED__

#include "bbtkAtomicBlackBox.h"
#include "bbstd_EXPORT.h"

namespace bbstd
{
  class bbstd_EXPORT Configuration
    : 
    public bbtk::AtomicBlackBox
  {
    BBTK_BLACK_BOX_INTERFACE(Configuration,bbtk::AtomicBlackBox);
    BBTK_DECLARE_OUTPUT(BinPath,std::string);
    BBTK_DECLARE_OUTPUT(DataPath,std::string);
    BBTK_DECLARE_OUTPUT(DocPath,std::string);
    BBTK_DECLARE_OUTPUT(FileSeparator,std::string);
    BBTK_DECLARE_OUTPUT(SystemType,int);
    BBTK_PROCESS(DoProcess);
    void DoProcess();

  };

  BBTK_BEGIN_DESCRIBE_BLACK_BOX(Configuration,bbtk::AtomicBlackBox);
  BBTK_NAME("Configuration");
  BBTK_AUTHOR("jpr@creatis.insa-lyon [dot] fr");
  BBTK_CATEGORY("misc");
  BBTK_DESCRIPTION("Gets configuration informations");
  BBTK_OUTPUT(Configuration,BinPath,"Binaries path",std::string,"directory name");
  BBTK_OUTPUT(Configuration,DataPath,"Data path",std::string,"directory name");
  BBTK_OUTPUT(Configuration,DocPath,"Documentation path",std::string,"directory name");
  BBTK_OUTPUT(Configuration,FileSeparator,"/ or \\",std::string,"");  
  BBTK_OUTPUT(Configuration,SystemType,"0=Linux 1=Windows",int,"");  
  BBTK_END_DESCRIBE_BLACK_BOX(Configuration);
}
// EO namespace bbstd

#endif //  __bbstdConfiguration_h_INCLUDED__
