#ifndef __bbvtkVecImageGaussianSmooth_h_INCLUDED__
#define __bbvtkVecImageGaussianSmooth_h_INCLUDED__
#include "bbtkAtomicBlackBox.h"
#include "iostream"

#include "vtkImageGaussianSmooth.h"
#include "vtkImageData.h"
#include <vector>

namespace bbvtk
{

class /*BBTK_EXPORT*/ VecImageGaussianSmooth
 : 
   public bbtk::AtomicBlackBox
{
  BBTK_BLACK_BOX_INTERFACE(VecImageGaussianSmooth,bbtk::AtomicBlackBox);
  BBTK_DECLARE_INPUT(In,std::vector<vtkImageData*>);
  BBTK_DECLARE_INPUT(StdDevX,double);
  BBTK_DECLARE_INPUT(StdDevY,double);
  BBTK_DECLARE_INPUT(StdDevZ,double);
  BBTK_DECLARE_INPUT(iImage,int);
  BBTK_DECLARE_OUTPUT(Out,std::vector<vtkImageData*>);
  BBTK_DECLARE_OUTPUT(OutImage,vtkImageData*);
  BBTK_PROCESS(Process);
  void Process();
  
  std::vector<vtkImageGaussianSmooth *> VecVtkimagegaussiansmooth;
  std::vector<vtkImageData*>			VecResult;
};

BBTK_BEGIN_DESCRIBE_BLACK_BOX(VecImageGaussianSmooth,bbtk::AtomicBlackBox);
BBTK_NAME("VecImageGaussianSmooth");
BBTK_AUTHOR("InfoTeam CREATIS-LRMN");
BBTK_DESCRIPTION("Vector of ImageGaussianSmooth");
BBTK_CATEGORY("filter");


BBTK_INPUT(VecImageGaussianSmooth,In,"Vector of input images",std::vector<vtkImageData*>,"");
BBTK_INPUT(VecImageGaussianSmooth,StdDevX,"Standard deviation in direction X",double,"");
BBTK_INPUT(VecImageGaussianSmooth,StdDevY,"Standard deviation in direction Y",double,"");
BBTK_INPUT(VecImageGaussianSmooth,StdDevZ,"Standard deviation in direction Z",double,"");
BBTK_INPUT(VecImageGaussianSmooth,iImage,"iImage ",int,"");
BBTK_OUTPUT(VecImageGaussianSmooth,Out,"Vector of output images",std::vector<vtkImageData*>,"");
BBTK_OUTPUT(VecImageGaussianSmooth,OutImage,"Image[iImage]",vtkImageData*,"");

BBTK_END_DESCRIBE_BLACK_BOX(VecImageGaussianSmooth);
}
// EO namespace bbvtk

#endif // __bbvtkVecImageGaussianSmooth_h_INCLUDED__

