/*=========================================================================
                                                                                
  Program:   bbtk
  Module:    $RCSfile: bbwxvtkViewer2D.h,v $
  Language:  C++
  Date:      $Date: 2009/05/15 14:58:08 $
  Version:   $Revision: 1.17 $
                                                                                
  Copyright (c) CREATIS (Centre de Recherche et d'Applications en Traitement de
  l'Image). All rights reserved. See Doc/License.txt or
  http://www.creatis.insa-lyon.fr/Public/bbtk/License.html for details.
                                                                                
     This software is distributed WITHOUT ANY WARRANTY; without even
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
     PURPOSE.  See the above copyright notices for more information.
                                                                                
=========================================================================*//**
 * \brief Short description in one line
 * 
 * Long description which 
 * can span multiple lines
 */
/**
 * \file 
 * \brief 
 */
/**
 * \class Viewer2D
 * \brief 
 */

#ifdef USE_WXWIDGETS
#ifdef USE_VTK

#ifndef __bbwxvtkViewer2D_h__
#define __bbwxvtkViewer2D_h__

#include "vtkImageData.h"
#include "wxvtkImageViewer2.h"
#include "vtkImplicitPlaneWidget.h"

#include "bbtkWxBlackBox.h"
#include "wxVTKRenderWindowInteractor.h"

namespace bbwxvtk
{
  //------------------------------------------------------------------------
  //------------------------------------------------------------------------
  //------------------------------------------------------------------------
  
  class /*BBTK_EXPORT*/ Viewer2D : public bbtk::WxBlackBox
  {    
    BBTK_BLACK_BOX_INTERFACE(Viewer2D,bbtk::WxBlackBox);
    
    BBTK_DECLARE_INPUT(Slice,       int);
    BBTK_DECLARE_INPUT(Orientation, int);
    BBTK_DECLARE_INPUT(In,          vtkImageData *);
    BBTK_DECLARE_OUTPUT(Out,        int);
    
    BBTK_DECLARE_OUTPUT(Renderer,vtkRenderer*);
    BBTK_PROCESS(Process);
    BBTK_CREATE_WIDGET(CreateWidget);
    //   BBTK_ON_SHOW_WIDGET(OnShowWidget);
    
    void Process();
    void CreateWidget(wxWindow*);
    //    void OnShowWidget();

  };
   
  //=================================================================
  // UserBlackBox description
  BBTK_BEGIN_DESCRIBE_BLACK_BOX(Viewer2D,bbtk::WxBlackBox);
  BBTK_NAME("Viewer2D");
  BBTK_AUTHOR("eduardo.davila@creatis.insa-lyon.fr");
  BBTK_DESCRIPTION("2D Viewer widget (vtk)");
  BBTK_CATEGORY("viewer");
  BBTK_INPUT(Viewer2D, Slice,       "Initial Slice number",                     int,            "");
  BBTK_INPUT(Viewer2D, Orientation, "Slicing orientation : 0:yz / 1:xz / 2:xy", int,            "");
  BBTK_INPUT(Viewer2D, In,          "Input Image",                              vtkImageData *, "");
  BBTK_OUTPUT(Viewer2D,Out,         "Current Slice number",                     int,            "");
  BBTK_OUTPUT(Viewer2D,Renderer,    "vtk Renderer",                             vtkRenderer*,   "");
  BBTK_END_DESCRIBE_BLACK_BOX(Viewer2D);
  //=================================================================

}//namespace bbwxvtk

#endif  //__bbwxvtkViewer2D_h__

#endif //USE_VTK
#endif //USE_WXWIDGETS
